#include "Plugin.h"
#include "scnl.h"

// Message hook
#if MESSAGEHOOK_ENABLED
	BOOL Plugin::MessageHook(PluginAPI::ConnectionInterface Connection,
							 BYTE MessageId, LPCVOID MessageData, DWORD MessageSize)
	{
		if (Connection == PluginAPI::Connection_BNCS) {
			if (MessageId == 0x25) {
				if((HighResolutionUptime() - lastrequestedlist) > 90000) {
					API.ProcessBotCommand("/mcplistgames");
					lastrequestedlist = HighResolutionUptime();
				}
			}

		}

		if (Connection == PluginAPI::Connection_MCP) {
			if (MessageId == 0x5) {
				/*
					0000:           2C 00 15 03 00 00 01 04 00 30 00 47 6F      ,........0.Go
					0010:  6C 64 77 72 61 70 34 73 63 72 69 70 74 00 31 30   ldwrap4script.10
					0020:  20 63 68 69 70 20 74 6F 70 61 7A 20 00             chip topaz .
				*/

				WORD id = ((LPWORD)MessageData)[0];
				DWORD index = ((LPDWORD)MessageData)[2];
				BYTE count = ((LPBYTE)MessageData)[6];
				DWORD status = ((LPDWORD)MessageData)[7];
				LPCSTR lpszGameName = ((char *)MessageData)+11;
				LPCSTR lpszGameDescription = ((char *)MessageData)+11+strlen(lpszGameName)+1;

				WriteOutputString(PluginAPI::LightBlue, "%s (%s) has %u players.", lpszGameName, lpszGameDescription, count);

			}
		}
		return FALSE;
	}
#endif

// Connection hook
#if CONNECTIONHOOK_ENABLED
	BOOL Plugin::ConnectionHook(PluginAPI::ConnectionInterface Connection,
								PluginAPI::ConnectionState EventCode, DWORDLONG PlatformId)
	{
		// Add code here
		return FALSE;
	}
#endif

// Plugin timer
#if PLUGINTIMER_ENABLED
	DWORD Plugin::PluginTimer(DWORD TimeDelay)
	{
		// Add code here
		return TimeDelay;
	}
#endif

// Command hook
#if COMMANDHOOK_ENABLED
	BOOL Plugin::CommandHook(LPCSTR Message, LPCSTR SendingUser, BOOL FromTelnet)
	{

		return FALSE;
	}
#endif

// Event hook
#if EVENTHOOK_ENABLED
	BOOL Plugin::EventHook()
	{
		// Add code here
		return FALSE;
	}
#endif

// Enum channel callback
BOOL Plugin::EnumChannelHook(LPCSTR UniqueName, LPCSTR Statstring, DWORD Flags, DWORD Ping,
							 BOOL Invisible, DWORD AccountNumber, DWORD RegAuthority)
{
	// Add code here
	return TRUE;
}

#if HIGHEST_REVISION >= 4
	// Enum filter callbacks
	BOOL Plugin::EnumUserFiltersHook(LPCSTR Filter)
	{
		// Add code here
		return TRUE;
	}

	BOOL Plugin::EnumMessageFiltersHook(LPCSTR Filter)
	{
		// Add code here
		return TRUE;
	}

	// Enum plugins callback
	BOOL Plugin::EnumLoadedPluginsHook(HINSTANCE PluginInst)
	{
		// Add code here
		return TRUE;
	}
#endif

BOOL Plugin::Initialize()
{
	// Initialization code here

	lastrequestedlist = HighResolutionUptime();

	return TRUE;
}

void Plugin::Terminate()
{
	// Termination code here
}
