#include "scnl.h"

__int64 lastrequestedlist;

void WriteOutputString(PluginAPI::OutputColor Color, char *text, ...)
{
	char buf[512] = "";
	char msg[512] = "";

	va_list argptr;
	va_start(argptr, text);
	vsprintf(msg, text, argptr);
	va_end(argptr);
	wsprintf(buf, "[scnl] %s\r\n", msg);
	API.WriteOutputTimestamp();
	API.SetOutputColor(Color);
	API.WriteOutputString(buf);
}

void QueueChatMessage(char *text, ...)
{
	char msg[512] = "";

	va_list argptr;
	va_start(argptr, text);
	vsprintf(msg, text, argptr);
	va_end(argptr);
	API.QueueChatMessage(msg, FALSE);
}

__int64 HighResolutionUptime(void) {
	LARGE_INTEGER lpPerformanceCount;
	LARGE_INTEGER lpFrequency;

	if (QueryPerformanceCounter(&lpPerformanceCount)) {
		QueryPerformanceFrequency(&lpFrequency);
		return ((lpPerformanceCount.QuadPart * 1000) / lpFrequency.QuadPart);
	} else
		return 0;
}
